package svc

import (
	"applet/app/db/model"
	"applet/app/enum"
	"applet/app/utils/logx"
	"fmt"
	"time"
	"xorm.io/xorm"
)

func SyncCentralKitchenForSchoolUserWithDayState(eg *xorm.Engine) {
	fmt.Println("sync central_kitchen_for_school_user_with_day state...")
	defer func() {
		if err := recover(); err != nil {
			_ = logx.Error(err)
		}
	}()

	now := time.Now()
	today := now.Format("2006-01-02")
	breakfastMealTime, _ := time.ParseInLocation("2006-01-02 15:04:05", now.Format("2006-01-02")+" 06:30", time.Local)
	lunchMealTime, _ := time.ParseInLocation("2006-01-02 15:04:05", now.Format("2006-01-02")+" 12:00", time.Local)
	dinnerMealTime, _ := time.ParseInLocation("2006-01-02 15:04:05", now.Format("2006-01-02")+" 17:00", time.Local)
	//1、判断当前已过早餐就餐时间
	if now.After(breakfastMealTime) {
		centralKitchenForSchoolUserWithDay := new(model.CentralKitchenForSchoolUserWithDay)
		centralKitchenForSchoolUserWithDay.State = enum.CentralKitchenForSchoolUserWithDayStateForAlready
		affected, err := eg.Where("state =?", enum.CentralKitchenForSchoolUserWithDayStateForWait).
			And("date =?", today).
			And("kind=?", enum.CentralKitchenForSchoolUserWithDayKindForBreakfast).
			Cols("state").Update(centralKitchenForSchoolUserWithDay)
		if err != nil {
			_ = logx.Error(err)
			fmt.Println(">>>>>>>>SyncCentralKitchenForSchoolUserWithDayState_breakfast_Err<<<<<<<<<<<<<<", err.Error())
		}
		fmt.Println("SyncCentralKitchenForSchoolUserWithDayState_breakfast_Affected>>>>>>>>>>>>>>>", affected)
	}

	//2、判断当前已过午餐就餐时间
	if now.After(lunchMealTime) {
		centralKitchenForSchoolUserWithDay := new(model.CentralKitchenForSchoolUserWithDay)
		centralKitchenForSchoolUserWithDay.State = enum.CentralKitchenForSchoolUserWithDayStateForAlready
		affected, err := eg.Where("state =?", enum.CentralKitchenForSchoolUserWithDayStateForWait).
			And("date =?", today).
			And("kind=?", enum.CentralKitchenForSchoolUserWithDayKindForLunch).
			Cols("state").Update(centralKitchenForSchoolUserWithDay)
		if err != nil {
			_ = logx.Error(err)
			fmt.Println(">>>>>>>>SyncCentralKitchenForSchoolUserWithDayState_lunch_Err<<<<<<<<<<<<<<", err.Error())
		}
		fmt.Println("SyncCentralKitchenForSchoolUserWithDayState_lunch_Affected>>>>>>>>>>>>>>>", affected)
	}

	//3、判断当前已过晚餐就餐时间
	if now.After(dinnerMealTime) {
		centralKitchenForSchoolUserWithDay := new(model.CentralKitchenForSchoolUserWithDay)
		centralKitchenForSchoolUserWithDay.State = enum.CentralKitchenForSchoolUserWithDayStateForAlready
		affected, err := eg.Where("state =?", enum.CentralKitchenForSchoolUserWithDayStateForWait).
			And("date =?", today).
			And("kind=?", enum.CentralKitchenForSchoolUserWithDayKindForDinner).
			Cols("state").Update(centralKitchenForSchoolUserWithDay)
		if err != nil {
			_ = logx.Error(err)
			fmt.Println(">>>>>>>>SyncCentralKitchenForSchoolUserWithDayState_dinner_Err<<<<<<<<<<<<<<", err.Error())
		}
		fmt.Println("SyncCentralKitchenForSchoolUserWithDayState_dinner_Affected>>>>>>>>>>>>>>>", affected)
	}

	return
}
